# PAX - the Pythonic API for XML
# developed by Lalo Martins <lalo@laranja.org>
# this file is placed on public domain

from xml.sax.saxutils import escape
import sys, types

_replace='replace'

def XML(obj, ns_map={}, encoding=sys.getdefaultencoding()):
    if obj is None:
        return u''
    try:
        # PAX object, or anything that can render itself into xml?
        return obj.__xml__(ns_map)
    except AttributeError:
        pass
    try:
        # unicode or ascii string?
        return unicode(escape(obj))
    except UnicodeError:
        # non-ascii string?
        return escape(unicode(obj, encoding, _replace))
    except AttributeError:
        pass
    try:
        # sequence?
        return ''.join([XML(child, ns_map, encoding) for child in obj])
    except TypeError:
        pass
    # I give up! Coerce it to string and return it...
    return escape(unicode(str(obj), encoding, _replace))

SequenceTypes = (types.ListType, types.TupleType)

def pack_list(self):
    "remove Nones, expand tuples"
    if hasattr(self, 'join'):
        return self
    is_tuple = type(self) is types.TupleType
    result = []
    for child in self:
        if child is None:
            continue
        if type(child) in SequenceTypes:
            result.extend(pack_list(child))
        else:
            result.append(child)
    if is_tuple:
        result = tuple(result)
    return result

try:
    import psyco
    psyco.bind(XML)
    psyco.bind(pack_list)
except:
    pass
